unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, GraphicEx, ExtDlgs;

type
  TfrmGlavna = class(TForm)
    lblSlika: TLabel;
    mnuGlavni: TMainMenu;
    mnuSlike: TMenuItem;
    itmUcitaj: TMenuItem;
    N1: TMenuItem;
    itmIzlaz: TMenuItem;
    PicDialog: TOpenPictureDialog;
    mnuTezina: TMenuItem;
    itmLako: TMenuItem;
    itmSrednje: TMenuItem;
    itmTesko: TMenuItem;
    pnlSlika: TImage;
    procedure itmUcitajClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pnlSlikaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    Playing: Boolean;
    Mapa: array[0..9, 0..9] of Integer;
    Tezina: Integer;
    Slika: TPicture;
    B: TBitmap;
    procedure PostaviMapu;
    procedure IscrtajSliku;
    procedure PomeriPolje(X, Y: Integer);
    function ProveriKraj: Boolean;
  public
    { Public declarations }
  end;

var
  frmGlavna: TfrmGlavna;

implementation

{$R *.dfm}

procedure TfrmGlavna.itmUcitajClick(Sender: TObject);
begin
  if PicDialog.Execute then
  begin
    Slika.LoadFromFile(PicDialog.FileName);
    B.Width := Slika.Width;
    B.Height := Slika.Height;
    B.Canvas.Draw(0, 0, Slika.Graphic);
    if itmLako.Checked then Tezina := 3
    else if itmSrednje.Checked then Tezina := 5
    else Tezina := 10;
    PostaviMapu;
    Playing := True;
    IscrtajSliku;
    pnlSlika.Visible := True;
  end;
end;

procedure TfrmGlavna.FormCreate(Sender: TObject);
begin
  Randomize;
  Slika := TPicture.Create;
  pnlSlika.Picture.Bitmap := TBitmap.Create;
  pnlSlika.Picture.Bitmap.Width := pnlSlika.Width;
  pnlSlika.Picture.Bitmap.Height := pnlSlika.Height;
  B := TBitmap.Create;
end;

procedure TfrmGlavna.FormDestroy(Sender: TObject);
begin
  Slika.Free;
  B.Free;
end;

procedure TfrmGlavna.IscrtajSliku;
var
  X, Y: Integer;
  pW, pH, sW, sH: Real;
begin
  pW := pnlSlika.Width / Tezina;
  pH := pnlSlika.Height / Tezina;
  sW := B.Width / Tezina;
  sH := B.Height / Tezina;
  for Y := 0 to Tezina - 1 do
    for X := 0 to Tezina - 1 do
    begin
      if Mapa[X,Y] <> 0 then
      begin
        pnlSlika.Picture.Bitmap.Canvas.CopyRect(
          Rect(Round(X * pW), Round(Y * pH), Round((X + 1) * pW), Round((Y + 1) * pH)),
          B.Canvas,
          Rect(Round((Mapa[X,Y] mod Tezina) * sW), Round((Mapa[X,Y] div Tezina) * sH), Round(((Mapa[X,Y] mod Tezina) + 1) * sW), Round(((Mapa[X,Y] div Tezina) + 1) * sH)));
      end
      else
        pnlSlika.Picture.Bitmap.Canvas.Rectangle(Round(X * pW),
          Round(Y * pH), Round((X + 1) * pW), Round((Y + 1) * pH));
    end;
end;

procedure TfrmGlavna.PostaviMapu;
var
  I: Integer;
begin
  for I := 0 to (Tezina * Tezina) - 1 do
    Mapa[I mod Tezina, I div Tezina] := I;
  while ProveriKraj do
    for I := 0 to 5000 * Tezina do
      PomeriPolje(Random(Tezina), Random(Tezina));
end;

procedure TfrmGlavna.pnlSlikaMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Playing then
  begin
    X := X div Round(pnlSlika.Width / Tezina);
    Y := Y div Round(pnlSlika.Height / Tezina);
    PomeriPolje(X, Y);
    IscrtajSliku;
    if ProveriKraj then
    begin
      ShowMessage('BRAVO!!!');
      Playing := False;
    end;
  end;
end;

procedure TfrmGlavna.PomeriPolje(X, Y: Integer);
begin
  if (X > 0) and (Mapa[X - 1, Y] = 0) then
  begin
    Mapa[X - 1, Y] := Mapa[X, Y];
    Mapa[X, Y] := 0;
  end;
  if (X < Tezina - 1) and (Mapa[X + 1, Y] = 0) then
  begin
    Mapa[X + 1, Y] := Mapa[X, Y];
    Mapa[X, Y] := 0;
  end;
  if (Y > 0) and (Mapa[X, Y - 1] = 0) then
  begin
    Mapa[X, Y - 1] := Mapa[X, Y];
    Mapa[X, Y] := 0;
  end;
  if (Y < Tezina - 1) and (Mapa[X, Y + 1] = 0) then
  begin
    Mapa[X, Y + 1] := Mapa[X, Y];
    Mapa[X, Y] := 0;
  end;
end;

function TfrmGlavna.ProveriKraj: Boolean;
var
  I: Integer;
begin
  Result := True;
  for I := 0 to (Tezina * Tezina) - 1 do
    if Mapa[I mod Tezina, I div Tezina] <> I then
    begin
      Result := False;
      Exit;
    end;
end;

end.
